// import msg from './msg/msg.vue'

// let plugins = {};

// plugins.install = function (Vue,option){
//      //添加全局属性 （或方法）
//     Vue.prototype.$msg = '我是msg';
//     Vue.prototype.$myMethod = function (e) {
//         console.log('666')
//     }

//     Vue.directive('focus', {
//         bind: function() {},
//         // 当绑定元素插入到 DOM 中。
//         inserted: function(el, binding, vnode, oldVnode) {
//             // 聚焦元素
//             el.focus();
//         },
//     });
//     Vue.mixin({
//         methods: {
//             mixinFn() {
//                 console.log('我是mixinFn方法');
//             }
//         }
//     });
//     //添加组件
//     Vue.component(msg.name, msg) // msg.name 组件的name属性
// }
// export default plugins

//多个组件是不是要写很多行Vue.component 那我们来改一下
// import msg from './msg/msg.vue'
// import button from './button/button.vue'
// import Vue from 'vue'
// let components = [
//     msg,
//     button
// ];

const requireComponent = require.context('./',true,/\.vue$/);


const install = (Vue) =>{
    if(install.installed) return
    install.installed
    //遍历注册组件
    // components.map(component=>{
    //     console.log(component);
    //     Vue.component(component.name,component)
    // })
    requireComponent.keys().map(component => {
        //第i个
        const config = requireComponent(component);
        const componentName = config.default.name;
        //注册组件 有一个原则 要在初始化根实例之前注册组件
        Vue.component(componentName,config.default || config)
    });
}
//正常环境，浏览器环境 node是没有window的
if(typeof window !== 'undefined' && window.Vue){
    //注册vue
    install(window.Vue)
}

export default{
    install,
    //当我们有些组件不想全局注册的时候 通过这个导出去
    // ...components
}